#ifndef RATE_ADJUSTER_H
#define RATE_ADJUSTER_H

class rateAdjuster {
	private:
		//to input einai to pososto tou packet loss
		double input_packet_loss;
		double input_power;
		//to threshold einai to ano orio
		double threshold;
		//to output einai to epithymito power,edo yparxei i proigoumeni timi tou power kai tithetai i kainouria
	        double output_power;
		//to coeff einai o syntelestis auksisis i meiosis tou output
		double coeff;
		//H adjust ypologizei to output synarthsei tou input
		void adjust();
	//	static rateAdjuster *inst;
		enum possibleStates { STATE_A, STATE_B, STATE_C, STATE_D,STATE_E,  PRE_STATE };
		possibleStates currentState;
		double low_region, upper_region, low_current_region, upper_current_region, region_length, previous_packet_loss, init_packet_loss;

	public:
		rateAdjuster(double initialPower) {input_packet_loss = initialPower; coeff = 0.05; threshold = 0.05; currentState = PRE_STATE;}
		rateAdjuster(double initialPower,double initialCoeff) {input_power = initialPower; coeff = initialCoeff;threshold = 0.05;currentState = PRE_STATE;}
		rateAdjuster(double initialPower,double initialCoeff,double mInput) {input_packet_loss = mInput;input_power = initialPower; coeff = initialCoeff; threshold = 0.05;currentState = PRE_STATE;}
		rateAdjuster(double initialPower,double initialCoeff,double mInput,double initialThres) {input_packet_loss = mInput;input_power = initialPower; coeff = initialCoeff; threshold = initialThres;currentState = PRE_STATE;}
		void setInput(double mInput) {input_packet_loss = mInput;};
		void setThreshold(double thres) {threshold = thres;};
		double getOutput() { adjust();return output_power; }
};		
#endif
